<?php use_helper('Object', 'I18N', 'Validation', 'tvtl', 'Javascript') ?>
<?php use_stylesheet('dropdown.css') ?>
<?php echo form_tag('/present/update', array('multipart'=>'true', 'id'=>'update')) ?>
  <?php echo input_hidden_tag('entry_id', $entry_id) ?>
  <div class="doc">
    <h2><?php echo isset($entry_id)? 'Chỉnh sửa '.$doc: 'Đưa '.$doc.' từ máy tính lên thư viện' ?></h2>
    <div class="content">
      <div style="height:5px"></div>
      <?php include_component('entry', 'selectfolder', array('cat_id'=>$cat_id)); ?>
      <?php include_component('entry', 'uploadhelp') ?>

      <div id="select_title" style="height:32px">
        <div class="span-2">Tiêu đề</div>
        <div class="span-11">
          <?php echo form_error('pr_name') ?>
          <?php echo input_tag('pr_name', $tblpresentation->getPrName(), array('onkeyup'=>'onChangeKeyword(this.value, event)', 'style'=>'width:350px', 'autocomplete'=>'off')) ?>
          <div id='listlesson'><?php include_component('present', 'lessondropdown', array('cat_id'=>$cat_id)) ?></div>
        </div>
      </div>
      <div style="height:32px">
        <div class="span-2">File dữ liệu</div>
        <div class="span-11"><?php echo form_error('pr_filename').input_file_tag('pr_filename', array('style'=>'width:250px', 'value'=>$sf_params->get('pr_filename'))) ?></div>
      </div>
      <div style="height:32px;<?php if ($catType==0) echo 'display:none;' ?>">
        <div class="span-2">Ảnh đại diện</div>
        <div class="span-11"><?php echo form_error('pr_thumb').input_file_tag('pr_thumb', array('style'=>'width:250px')) ?></div>
      </div>
      <div style="height:32px">
        <div class="span-2">Nguồn</div>
        <div class="span-11">
          <?php echo form_error('pr_source').object_input_tag($tblpresentation, 'getPrSource',  array('style'=>'width:250px')) ?>
          <?php echo '<font color="Gray"> (Nếu tự làm thì không cần nhập)</font>' ?>
        </div>
      </div>
      <?php if (blogStore::isAdministator() && blogStore::$blog->getBlCommercial()): ?>
      <div style="height:32px">
        <div class="span-2">Giá bán</div>
        <div class="span-11"><?php echo form_error('pr_price').object_input_tag($tblpresentation, 'getPrPrice', array('style'=>'width:70px')).' (đồng)' ?></div>
      </div>
      <?php endif ?>

      <br />
      <?php include_component('entry', 'uploadhelp', array('type'=>$catType, 'doc'=>$doc)) ?>
      <hr />
      <center>
        <?php echo submit_tag(__('Save'), array('id'=>'smbtn', 'style'=>'width:80px', 'onclick'=>'return validate();')) ?>
        <?php if ($entry_id) echo '&nbsp;&nbsp;'.link_to(__('Cancel'), '/present/show?entry_id='.$entry_id) ?>
      </center>
    </div>
  </div>
</form>

<script>
  $("pr_name").focus();
<?php if ($tblpresentation->getPrLesson()): ?>
  selectLesson(<?php echo $tblpresentation->getPrLesson() ?>);
  updateLessonTitle();
<?php endif; ?>

  function validate() {
    if ($("dropdown-list").style.display != "none" && document.activeElement.id == "pr_name") {updateLessonTitle(); return false;}
    if ($("cat_error") != undefined) {alert($F("cat_error")); return false;}
    if (!checkError("pr_name", "3<=v.length && v.length<=128", "Tiêu đề <?php echo $doc ?> phải dài từ 3 đến 128 ký tự")) return false;
<?php if (!isset($entry_id)): ?>
    if (!checkError("pr_filename", "v.length>0", "Bạn phải chọn file <?php echo $doc ?> để đưa lên")) return false;
<?php endif; ?>
    var invalid_type_msg = <?php echo ($catType != -3)?
    '"Bạn phải chọn các dạng file <b>'.strtoupper(join(', ', $exts)).'</b> hoặc các file nén (<b>'.strtoupper(join(', ', $zipExts)).'</b>) có chứa file này"':
    '"Bạn phải chọn các file nén (<b>'.strtoupper(join(', ', $zipExts)).'</b>) có chứa gói bài giảng SCORM"' ?>;
    if (!checkError("pr_filename", "v.length==0 || v.match(/\.(<?php echo join('|', array_merge($exts, $zipExts)) ?>)$/gi)!=null", invalid_type_msg)) {
      $("sendcomment").style.display = "block";
      return false;
    }
    if ($F("lesson_count") != 0) {
      var lesson = $F("pr_lesson");
      if (lesson == -1 || $F("pr_name").toLowerCase() != $("lesson-"+lesson).firstChild.innerHTML.trim().toLowerCase()) {
        var encoded_title = encodeURIComponent(encodeURIComponent($F("pr_name")).replace(/\./g, "%2E"));
        var confirm_url = "<?php echo url_for('/present/confirm') ?>/cat_id/" + $F("cat_id") + "/title/" + encoded_title;
        Modalbox.show(confirm_url, {title: "Xác nhận tiêu đề tài liệu"});
        return false;
      }
    }
    $("update").submit();
    $("smbtn").disabled = true;
    return false;
  }

  function updateComponentsBelongToCategory(cat_id) {
    var url = "<?php echo url_for('/present/getlessonlisttag') ?>/cat_id/" + cat_id;
    new Ajax.Updater("listlesson", url, {asynchronous:true, evalScripts:true, onComplete:function() {
      selectLesson(searchLesson($F("pr_name")));
      if ($F("pr_lesson") != -1) $("dropdown-list").style.display = "";
      $("pr_name").focus();
    }});
  }

  Event.observe(document, "click", function (event) {
    if ($("lesson_count").value == 0) return;
    var inside = event.element().id == "pr_name" || event.element().id == "reselect";
    $("dropdown-list").style.display = inside? "": "none";
  });

  function onChangeKeyword(keyword, event) {
    if ($("lesson_count").value == 0) return;
    var c = event.which;
    if (c == 27) $("dropdown-list").style.display = "none";
    else if (c == 13) {if ($("dropdown-list").style.display != "none") updateLessonTitle();}
    else if (c == 8 || c == 32 || c == 46 || c >= 48 && c <= 90 || c >= 186) {
      $("dropdown-list").style.display = "";
      selectLesson(searchLesson(keyword));
    }
  }

  function selectLesson(id) {
    var current = $("pr_lesson").value;
    if (current != -1) $("lesson-"+current).className = "";
    $("pr_lesson").value = id;
    if (id != -1) {
      $("dropdown-list").scrollTop = $("lesson-"+id).offsetTop;
      $("lesson-"+id).className = "active";
    }
  }

  function updateLessonTitle() {
    var id = $("pr_lesson").value;
    if (id != -1) $("pr_name").value = $("lesson-"+id).firstChild.innerHTML;
  }

  function searchLesson(keyword, event) {
    var skey = vietDecode(keyword).toLowerCase();
    skey = skey.replace(/^(tuan|chuong|bai|tiet|toan|toan hoc|ngu van|van|van hoc|tieng anh|anh|vat ly|ly|hoa hoc|hoa|sinh hoc|sinh|lich su|su|dia ly|dia|gdcd|am nhac|my thuat|the duc|cong nghe|tin hoc|tin|vat li|li|dia li|mi thuat|dai so|hinh hoc) *[\divx]+\W*/, '');
    if (skey == "") return -1;
    var min = 1000;
    var id = -1;
    for (var c = 1; c <= 2; c++) {
      if (c == 2) skey = skey.replace(/[^\w]/g, '');
      for (var i = 1; i <= $("lesson_count").value; i++) {
        var lesson = $("lesson-"+i).firstChild.innerHTML;
        var data = vietDecode(lesson).toLowerCase();
        if (c == 2) data = data.replace(/[^\w]/g, '');
        var pos = data.indexOf(skey);
        if (pos >= 0 && pos < min) {min = pos; id = i;};
      }
      if (id != -1) break;
    }
    return id;
  }
</script>
